//=============================================================================
// Version 1
// Einfach:
// Mensch : Computer
// Mensch hat weiss
// Computer hat schwarz
// Computer spielt ganz einfach - nimmt das erste freie Feld
// Ganz einfache Konsolenausgabe & Konsoleneingabe

#include <iostream>
#include "computer.hpp"
#include "human.hpp"
#include "tictactoe.hpp"
using namespace std;

//-----------------------------------------------------------------------------

int main()
{
   cout << "WS 2024/25 Tic-Tac-Toe 1\n\n";

   // 1. Spiel erzeugen
   TicTacToe ttt;
   
   // 2. Spiel ausgeben
   cout << ttt << '\n';

   for (;;)
   {
      // 3. Mensch nach seinem Zug fragen
      Move m = askHumanForMove(ttt);

      // 4. Ausgabe Zug
      cout << "\nMensch macht Zug: " << m << "\n\n";

      // 5. Zug wird gesetzt
      ttt.set(m);

      // 6. Spiel ausgeben
      cout << ttt << '\n';

      // 7. berprfen, ob Mensch gewonnen hat: ja => Spielende mit Meldung
      if (ttt.hasWin(m.getGameColor()))
      {
         cout << "Gratulation - Mensch hat gewonnen - juhuuu...\n";
         break;
      }

      // 8. berprfen, ob das Spiel am Ende ist: ja => remis => Spielende mit Meldung
      if (ttt.isFull())
      {
         cout << "Spiel ist Remis ausgegangen...\n";
         break;
      }

      // 9. Computer nach seinem Zug fragen
      m = askComputerForMove(ttt);

      // 10. Ausgabe Zug
      cout << "\nComputer macht Zug: " << m << "\n\n";

      // 11. Zug wird gesetzt
      ttt.set(m);

      // 12. Spiel ausgeben
      cout << ttt << '\n';

      // 13. berprfen, ob Computer gewonnen hat: ja => Spielende mit Meldung
      if (ttt.hasWin(m.getGameColor()))
      {
         cout << "Gratulation - Computer hat gewonnen - juhuuu...\n";
         break;
      }

      // 14. Springe zu Schritt 3
   }
}
