#ifndef MOVE_HPP
#define MOVE_HPP

#include <iostream>
#include "gamecolor.hpp"

class Move
{
public:
   Move(int row, int col, GameColor gc) : mRow{row}, mCol{col}, mGameColor{gc} {}

   int getRow() const { return mRow; }
   int getCol() const { return mCol; }
   GameColor getGameColor() const { return mGameColor; }

   friend std::ostream& operator<<(std::ostream&, const Move&);

private:
   int mRow;
   int mCol;
   GameColor mGameColor;
};

#endif
